#version 300 es

precision highp sampler2DArray;

layout( location = 0 ) in vec3 attrib_pos;
layout( location = 3 ) in vec2 attrib_uv;

layout(std140) uniform glfx_GLOBAL
{
	mat4 glfx_MVP;
	mat4 glfx_PROJ;
	mat4 glfx_MV;
	vec4 unused_spinner;
	vec4 buttonPos[16];	// max number of buttons
	vec4 buttonColor[16];
};
layout(std140) uniform glfx_INSTANCES
{
	vec4 glfx_IDATA[48];
};
uniform uint glfx_CURRENT_I;
#define glfx_T_SPAWN (glfx_IDATA[glfx_CURRENT_I].x)
#define glfx_T_ANIM (glfx_IDATA[glfx_CURRENT_I].y)
#define glfx_ANIMKEY (glfx_IDATA[glfx_CURRENT_I].z)

out vec2 var_uv;

out float var_a;

out vec4 var_color;

uniform sampler2D tex;

void main()
{
	float aspect = glfx_PROJ[1][1]/glfx_PROJ[0][0];
	vec2 s = vec2(sign(glfx_PROJ[0][0])/aspect,sign(glfx_PROJ[1][1]))*3./4.;

	uint button_index = glfx_CURRENT_I;

	vec2 pos = attrib_pos.xy;
	pos.x *= 0.95;
	pos.y *= 1.2;
	vec2 buttonXY = buttonPos[glfx_CURRENT_I].xy;
	gl_Position = vec4((pos*(0.2) + buttonXY)*s,-1.,1.);
	var_color = buttonColor[glfx_CURRENT_I];
	var_uv = attrib_uv;
}
