function Effect() {
	var self = this;
	var x = 0.0;
	var y = -1.2;
	var index = 0;

	this.buttonsList = [];

	this.definedHaptic;

	this.init = function() {
		for (var i = 0; i < 4; i++) {
			y += 0.5;
			x = -1;
			for (var j = 0; j < 4; j++) {
				x += 0.4;
				self.buttonsList.push(new Button(x, y, index));
				index++;
			}
		}
		Api.print(self.buttonsList);
	}

	this.restart = function () {
		Api.meshfxReset();
		self.init();
	}

	this.faceActions = [];
	this.noFaceActions = [];

	this.videoRecordStartActions = [];
	this.videoRecordFinishActions = [];
	this.videoRecordDiscardActions = [];
}

function Button(x, y, meshId, meshName, texName) {
	this.x = x;
	this.y = y;
	this.id = meshId;
	var self = this;
	this.definedHaptic = undefined;

	var colors = {
		notDefined: '1.0 0.0 0.0 1.0',
		defined: '0.0 1.0 0.0 1.0',
	}

	var textures = {
		haptic_vibrate: {
			available: 'haptic_vibrate_available.png',
			notAvailable: 'haptic_vibrate_not_available.png'
		},
		haptic_peak: {
			available: 'haptic_peak_available.png',
			notAvailable: 'haptic_peak_not_available.png'
		},
		haptic_pop: {
			available: 'haptic_pop_available.png',
			notAvailable: 'haptic_pop_not_available.png'
		},
		haptic_canceled: {
			available: 'haptic_canceled_available.png',
			notAvailable: 'haptic_canceled_not_available.png'
		},
		haptic_try_again: {
			available: 'haptic_try_again_available.png',
			notAvailable: 'haptic_try_again_not_available.png'
		},
		haptic_failed: {
			available: 'haptic_failed_available.png',
			notAvailable: 'haptic_failed_not_available.png'
		},
		haptic_success: {
			available: 'haptic_success_available.png',
			notAvailable: 'haptic_success_not_available.png'
		},
		haptic_warning: {
			available: 'haptic_warning_available.png',
			notAvailable: 'haptic_warning_not_available.png'
		},
		haptic_error: {
			available: 'haptic_error_available.png',
			notAvailable: 'haptic_error_not_available.png'
		},
		haptic_light: {
			available: 'haptic_light_available.png',
			notAvailable: 'haptic_light_not_available.png'
		},
		haptic_medium: {
			available: 'haptic_medium_available.png',
			notAvailable: 'haptic_medium_not_available.png'
		},
		haptic_heavy: {
			available: 'haptic_heavy_available.png',
			notAvailable: 'haptic_heavy_not_available.png'
		},
		haptic_selection: {
			available: 'haptic_selection_available.png',
			notAvailable: 'haptic_selection_not_available.png'
		},
		haptic_vibrate_with_params_duration: {
			available: 'haptic_vibrate_with_params(duration)_available.png',
			notAvailable: 'haptic_vibrate_with_params(duration)_not_available.png'
		},
		haptic_vibrate_with_params_amplitude: {
			available: 'haptic_vibrate_with_params(amplitude)_available.png',
			notAvailable: 'haptic_vibrate_with_params(amplitude)_not_available.png'
		},
	}

	var isAndroid = Api.haptic_is_android_api_available();

	var counter;
	var duraions;
	var amplitudes;

	this.duraions = duraions;
	this.amplitudes = amplitudes;

	if (isAndroid) {
		counter = -1;
		duraions = [100, 1000, 1500];
		amplitudes = [-1, 0, 1];
	}

	switch (this.id) {
		case 0:
			defineHaptic(Api.haptic_vibrate, textures.haptic_vibrate);
			break;
		case 1:
			defineHaptic(Api.haptic_peak, textures.haptic_peak)
			break;
		case 2:
			defineHaptic(Api.haptic_pop, textures.haptic_pop);
			break;
		case 3:
			defineHaptic(Api.haptic_canceled, textures.haptic_canceled);
			break;
		case 4:
			defineHaptic(Api.haptic_try_again, textures.haptic_try_again);
			break;
		case 5:
			defineHaptic(Api.haptic_failed, textures.haptic_failed);
			break;
		case 6:
			defineHaptic(Api.haptic_success, textures.haptic_success);
			break;
		case 7:
			defineHaptic(Api.haptic_warning, textures.haptic_warning);
			break;
		case 8:
			defineHaptic(Api.haptic_error, textures.haptic_error);
			break;
		case 9:
			defineHaptic(Api.haptic_light, textures.haptic_light);
			break;
		case 10:
			defineHaptic(Api.haptic_medium, textures.haptic_medium);
			break;
		case 11:
			defineHaptic(Api.haptic_heavy, textures.haptic_heavy);
			break;
		case 12:
			defineHaptic(Api.haptic_selection, textures.haptic_selection);
			break;
		case 13:
			defineHaptic(Api.haptic_vibrate_with_params, textures.haptic_vibrate_with_params_duration);
			break;
		case 14:
			defineHaptic(Api.haptic_vibrate_with_params, textures.haptic_vibrate_with_params_amplitude);
			break;
		default:
			Api.meshfxMsg( "shaderVec4", 0, this.id + 16, "1.0 1.0 1.0 1.0");
			break;
	}


	this.trigger = function() {
		Api.print('!!!ID: ' + this.id);
		Api.print("!!!HAPTIC: " + this.definedHaptic);
		if (this.definedHaptic) {
			isAndroid ? this._vibrateAndroid() : this._vibrateIOS();
		} else {
			Api.print('haptic is not defined');
		}
	}


	this._vibrateAndroid = function() {
		if (this.definedHaptic === Api.haptic_vibrate_with_params) {
			counter++;
			if (this.id === 13) {
				counter = counter >= duraions.length ? 0 : counter;
				this.definedHaptic(duraions[counter], -1);
			} else if (this.id === 14) {
				counter = counter >= amplitudes.length ? 0 : counter;
				this.definedHaptic(1000, amplitudes[counter]);
			}
		} else {
			this.definedHaptic();
		}
	}


	this._vibrateIOS = function() {
		if (this.definedHaptic === Api.haptic_vibrate_with_params) {
			this.definedHaptic(1000, -1);
		} else {
			this.definedHaptic();
		}
	}


	function defineHaptic(haptic, texture) {

		var iosAPI = Api.haptic_is_ios_api_available();
		var andAPI = Api.haptic_is_android_api_available();
		Api.meshfxMsg("spawn", meshId, 0, meshName || "quad.bsm2");
		if(iosAPI) {
			if (
					haptic === Api.haptic_vibrate ||
					haptic === Api.haptic_peak ||
					haptic === Api.haptic_pop ||
					haptic === Api.haptic_canceled ||
					haptic === Api.haptic_try_again ||
					haptic === Api.haptic_failed ||
					haptic === Api.haptic_success ||
					haptic === Api.haptic_warning ||
					haptic === Api.haptic_error ||
					haptic === Api.haptic_light ||
					haptic === Api.haptic_medium ||
					haptic === Api.haptic_heavy ||
					haptic === Api.haptic_selection
				)
			{
				Api.meshfxMsg("tex", self.id, 0, texture.available);
				Api.meshfxMsg( "shaderVec4", 0, self.id + 16, colors.defined);
			} else {
				Api.meshfxMsg("tex", self.id, 0, texture.notAvailable);
				Api.meshfxMsg( "shaderVec4", 0, self.id + 16, colors.notDefined);
			}
			self.definedHaptic = haptic;

		} else if(andAPI) {
			if (
				haptic === Api.haptic_vibrate ||
				haptic === Api.haptic_vibrate_with_params
				)
			{
				Api.meshfxMsg("tex", self.id, 0, texture.available);
				Api.meshfxMsg( "shaderVec4", 0, self.id + 16, colors.defined);
			} else {
				Api.meshfxMsg("tex", self.id, 0, texture.notAvailable);
				Api.meshfxMsg( "shaderVec4", 0, self.id + 16, colors.notDefined);
			}
			self.definedHaptic = haptic;
		}
	}

	var str = x.toFixed(1) + ' ' + y.toFixed(1) + ' 0.0 1.0';
	Api.meshfxMsg( "shaderVec4", 0, meshId, str);
}

var effect = new Effect();
configure(effect);


function onTouchesBegan(touches) {

	var x = touches[0].x;
	var y = touches[0].y;
	var button = findButton(x, y, effect.buttonsList);
	button.trigger();

}


function findButton(x, y, btnsArr) {
	var xDifferenceArr = [];
	var yDifferenceArr = [];

	btnsArr.forEach(function(button, index) {

		var objX = {
			dif: undefined,
			index: undefined
		};

		var objY = {
			dif: undefined,
			index: undefined
		};

		if (x <= 0 && button.x <= 0 && y <= 0 && button.y <= 0) {
			Api.print(objX);
			_setObjParams(objX, objY, index, button, x, y);
			_pushToArrays(objX, objY);
		} else if (x > 0 && button.x > 0 && y > 0 && button.y > 0) {
			_setObjParams(objX, objY, index, button, x, y);
			_pushToArrays(objX, objY);
		} else if (x <= 0 && button.x <= 0 && y > 0 && button.y > 0) {
			_setObjParams(objX, objY, index, button, x, y);
			_pushToArrays(objX, objY);
		} else if (x > 0 && button.x > 0 && y <= 0 && button.y <= 0) {
			_setObjParams(objX, objY, index, button, x, y);
			_pushToArrays(objX, objY);
		}
	});


	function _setObjParams(obj1, obj2, i, btn, x, y) {
		obj1.dif = getSum(btn.x, x);
		obj1.index = i;
		obj2.dif = getSum(btn.y, y);
		obj2.index = i;
	}


	function _pushToArrays(objX, objY) {
		xDifferenceArr.push(objX);
		yDifferenceArr.push(objY);
	}

	var minX = findMin(xDifferenceArr);
	var minY = findMin(yDifferenceArr);

	var newXArr = [];
	var newYArr = [];

	xDifferenceArr.forEach(function(element) {
		if (element.dif === minX) {
			newXArr.push(element.index);
		}
	});

	yDifferenceArr.forEach(function(element) {
		if (element.dif === minY) {
			newYArr.push(element.index);
		}
	});

	for (var i = 0; i < newXArr.length; i++) {
		for (var j = 0; j < newYArr.length; j++) {
			if (newXArr[i] === newYArr[j]) {
				return btnsArr[newXArr[i]];
			}
		}
	}
}


function getSum(val1, val2) {
	if(val1 <= 0 && val2 <= 0 || val1 > 0 && val2 > 0) {
		return Math.abs(val1 - val2);
	} else {
		return Math.abs(val1 + val2);
	}
}


function findMin(array) {
	min = array[0].dif;
  max = min;
  for (var i = 1; i < array.length; ++i) {
      if (array[i].dif < min) min = array[i].dif;
	}
	return min;
}



//--------------HELP FUNCTIONS---------------
function triggerButton(effect, id) {
	effect.buttonsList[id].trigger();
}


function triggerAndroidHaptics(effect, id) {
	effect.faceActions.push(
			(function(effect, id) {
			var timer = new Date().getTime();
			var delay = 2000;
			var effect = effect;
			var id = id;
			var counter = 0;
			return function() {
				var now = new Date().getTime();

				if(now >= timer + delay) {
					counter++;
					effect.buttonsList[id].trigger();
					Api.print("ID: " + id);
					Api.print("HAPTIC: " + effect.buttonsList[id].definedHaptic);
					timer = now;
				}

				if (counter >= 6) {
					effect.faceActions = [];
				}
			}
		})(effect, id)
	);
}
//END HELP FUNCTIONS

// triggerAndroidHaptics(effect, 14);

function onTouchesMoved() {}
function onTouchesEnded() {}

Api.print("кнопки идут снизу вверх, слева-направо, начиная с левой нижней \n");
Api.print("id: 0 ---> haptic_vibrate\n");
Api.print("id: 1 ---> haptic_peak\n");
Api.print("id: 2 ---> haptic_pop\n");
Api.print("id: 3 ---> haptic_canceled\n");
Api.print("id: 4 ---> haptic_try_again\n");
Api.print("id: 5 ---> haptic_failed\n");
Api.print("id: 6 ---> haptic_success\n");
Api.print("id: 7 ---> haptic_warning\n");
Api.print("id: 8 ---> haptic_error\n");
Api.print("id: 9 ---> haptic_light\n");
Api.print("id: 10 ---> haptic_medium\n");
Api.print("id: 11 ---> haptic_heavy\n");
Api.print("id: 12 ---> haptic_selection\n");
Api.print("id: 13 ---> haptic_vibrate_with_params duration\n");
Api.print("id: 14 ---> haptic_vibrate_with_params amplitude\n");
Api.print("id: 15 ---> NOT USED\n");

